export 'axl_map/map.dart';
export 'axl_map/map/axl_marker.dart';
export 'axl_map/map/axl_latlng.dart';
export 'axl_map/map/axl_base_map.dart';
export 'axl_map/map/axl_map_option.dart';
import 'dart:io';
import 'dart:typed_data';
import 'package:axl_map/axl_map/map/axl_map_option.dart';
import 'package:flutter/services.dart';
import 'axl_map/map/axl_base_map.dart';
import 'package:path_provider/path_provider.dart';
import 'package:path/path.dart';

typedef AxlBaseMap MapGenerator(AxlMapOptions options);

class MapBuilder {
  AxlBaseMap _map;
  static MapBuilder _instance = MapBuilder.newInstance();
  static MapBuilder get instance => _instance;
  MapGenerator generatorOnline;
  MapGenerator generatorOffline;
  AxlMapCache mapCache;
  bool onlineMode = true;

  MapBuilder.newInstance() {
  }

  void register(
    MapGenerator mapOnline, MapGenerator mapOffline, bool onlineMode, AxlMapCache cache) {
    this.generatorOffline = mapOffline;
    this.generatorOnline = mapOnline;
    this.onlineMode = onlineMode;
    this.mapCache = cache;
  }

  void setMapMode(bool mapMode) {
    this.onlineMode = mapMode;
    _map = null;
  }

  AxlBaseMap createMap(AxlMapOptions options) {
    var generatortmp = this.generatorOnline;
    if (this.onlineMode == false ) {
      generatortmp = this.generatorOffline;
    }

    /// override mapzoom, fix min = 12
    if (this.onlineMode == false) {
      options.minZoom = 12.0;
      options.maxZoom = 18.0;
      options.zoom = 12.0;
    }
      if (_map == null) {
        _map = generatortmp(options);
      } else {
        _map.options = options;
      }
      return _map;
  }
}
