import 'package:axl_map/axl_map.dart';
import 'package:flutter/cupertino.dart';
import 'package:axl_map/axl_map/map/axl_map_option.dart';
import 'package:axl_map/axl_map/map.dart';

class AxlMap extends StatefulWidget {
  AxlMapOptions options;
  final Key key;

  AxlMap({this.options, this.key}) {}

  @override
  State<StatefulWidget> createState() {
    return _AxlMapState();
  }
}

class _AxlMapState extends State<AxlMap> {
  bool _onlineMode;
  AxlBaseMap _mapBase;

   _generatorMap() {
    _mapBase = MapBuilder.instance.createMap(widget.options);
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  void initState() {
    super.initState();
    this._initwidget();
  }

  _initwidget() {
    _generatorMap();
    _mapBase.initMap();
    _mapBase.changeDisplayMode = _setMapMode;
    WidgetsBinding.instance.addPostFrameCallback((_) {});
  }

  @override
  Widget build(BuildContext context) {
    WidgetsBinding.instance
        .addPostFrameCallback((_) => _mapBase.onAfterBuild(context));
       
    return _mapBase.renderMap(context);
  }

  _setMapMode(bool onlineMode) {
    if (MapBuilder.instance.onlineMode != onlineMode) {
      MapBuilder.instance.setMapMode(onlineMode);
      this._initwidget();
      this.setState(() {
        _onlineMode = onlineMode;
      });
    }
  }
}
