import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'axl_map_option.dart';


abstract class AxlBaseMap {
  AxlMapOptions options;
  bool finishedLoadDatabase;

  AxlBaseMap({this.options, finishedLoadDatabase });
  void Function(bool) changeDisplayMode;
  
  void initMap();
  void dispose();

  void onAfterBuild(BuildContext context);
  Widget renderMap(BuildContext context);
  void addPostFrameCallback() {
  }
}

abstract class AxlMapCache {
  void downloadAssignment(String baseURL,String assignmentID);
  Future<bool> didExitAssignment(String assignmentID);
  void deleteAssignment(String assignmentID);
}