import 'dart:io';

import 'package:axl_map/axl_map.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'axl_marker.dart';

class AxlMapOptions {
  double width;
  double height;
  List<AxlMarker> markers;
  List<AxlLatLng> bounds;
  bool enablePolyline;
  List<List<AxlLatLng>> polylines;
  double polylineStrokeWidth;
  Color polylineColor;

  bool enablePolygon;
  List<List<AxlLatLng>> polygons;
  double polygonStrokeWidth;
  Color polygonColor;
  Color polygonBorderColor;

  double zoom;
  double maxZoom;
  double minZoom;
  EdgeInsets padding;
  String tile;
  File mbtilesFile;

  bool showCurrentLocation;
  bool focusCurrentLocation;
  double bufferBounds;
  final String cachePath;
  final String resourcePath;

  String assignmentID;

  AxlMapOptions(
      {this.width,
      this.height,
      this.zoom,
      this.maxZoom,
      this.minZoom,
      this.markers,
      this.bounds,
      this.enablePolyline,
      this.polylines,
      this.polylineStrokeWidth,
      this.polylineColor,
      this.padding,
      this.tile: "https://api.mapbox.com/styles/v1/mapbox/streets-v11/tiles/256/{z}/{x}/{y}@2x?access_token=pk.eyJ1IjoiYXhsZWhpcmVkZXYiLCJhIjoiY2s2aGo3cmFrMnVrazNlcGp3bTZqbTBhMyJ9.6gCs85XFqpbBM5DE-rDMdg",
      this.enablePolygon,
      this.polygons,
      this.polygonStrokeWidth,
      this.polygonBorderColor,
      this.polygonColor, 
      this.mbtilesFile,
      this.showCurrentLocation: true,
      this.focusCurrentLocation: true,
      this.bufferBounds = 0.02,
      this.cachePath,
      this.resourcePath, 
      this.assignmentID = ""});
}
